/***************************************************************************
 *   Copyright (C) 2003, 2004 by Johnathan Burchill                        *
 *   jkerrb@shaw.ca                                                        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/

#ifndef KDARDIALOG_H
#define KDARDIALOG_H

#include "kdardlg.h"
#include "kdarWarningEvent.h"

#include <qevent.h>

class KDarConfig;
class kdar;
class KListView;
class controller;

class kdarDialog : public KDARDlg
{
  Q_OBJECT

public:
  kdarDialog( controller * archiveController, QWidget* parent = 0, const char* name = 0, WFlags fl = 0 );
  ~kdarDialog();
  /*$PUBLIC_FUNCTIONS$*/
  virtual bool          askUserQuestion ( const QString userQuestion );

public slots:
  /*$PUBLIC_SLOTS$*/
  virtual void          slotArchiveChoose(const QString & text);
  virtual void          slotArchiveChoose();
  virtual void          slotArchiveDescend(QListViewItem * expandItem);
  virtual void          slotArchiveContextMenu( KListView *, QListViewItem *, const QPoint & );
  virtual void          slotArchiveOpenFromDoubleClick(QListViewItem * item);
                  void          setKDarConfig( KDarConfig * );

protected:
  /*$PROTECTED_FUNCTIONS$*/
    virtual void dragEnterEvent(QDragEnterEvent *event);
    virtual void dropEvent(QDropEvent *e);
//    virtual void customEvent( QCustomEvent *e );
protected slots:
  /*$PROTECTED_SLOTS$*/

private:

        KDarConfig * kdarConfig() const;
        kdar * m_kdar;
        KDarConfig * m_kdc;
    controller *m_controller;
};

#endif

